Foreman - Bug #10310

db:migrate fails to find _primary?_ method on Nic::BMC
04/29/2015 11:31 AM - Daniel Khodaparast

Status: Resolved

Priority: High

Assignee: Marek Hulan

Category: DB migrations

Target version:

Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.8.0
Bugzilla link: Red Hat JIRA:

Pull request:

Description

[root@foreman—-dev-001 opt]# foreman-rake db:migrate --trace

** Invoke db:migrate (first_time)

** Invoke environment (first_time)

** Execute environment

Workaround for RbVmomi may not work as ComputeResource is already loaded: ComputeResource
** Invoke db:load_config (first_time)

** Execute db:load_config

** Execute db:migrate

== ExtractNicAttributes: migrating
—-— add_column (:nics, :provider, :string)

-> 0.0749s

—-— add_column (:nics, :username, :string)
-> 0.0239s

-— add_column(:nics, :password, :string)
-> 0.0206s

—— Extracting serialized attributes
rake aborted!
An error has occurred, all later migrations canceled:

undefined method "primary?' for #<Nic::BMC:0x000000062a8a68>

/opt/rh/rubyl93/root/usr/share/gems/gems/activemodel-3.2.8/1lib/active_model/attribute_methods.rb:4

07:in "method_missing'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/attribute_methods.rb

:149:in "method_missing'
/usr/share/foreman/app/models/nic/managed.rb:91:in ‘update_lookup_value_fqgdn_matchers'

/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.

n ~_run_ 4185504911635280971__ _save_ 2102913221158532651___callbacks'

/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.

n ' _ _run_callback'

/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.

n " _run_save_callbacks'

/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.

“run_callbacks'

rb:449:1

rb:405:1

rb:385:1

rb:81:in

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/callbacks.rb:264:1in

‘create_or_update'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/persistence.

“save'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1ib/active_record/validations.

“save'

rb:84:in

rb:50:1in

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/attribute_methods/di

rty.rb:22:in "~ save'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:241:

in “block (2 levels) in save'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:295:

in "block in with_transaction_returning_status'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/
abstract/database_statements.rb:192:in "transaction'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
in “transaction’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
in “with_transaction_returning_status'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
in “block in save'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
in “rollback_active_record_state!'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
in "~ save'

2.8/1lib/active_record/transactions.rb:208:

2.8/1lib/active_record/transactions.rb:293:

2.8/lib/active_record/transactions.rb:241:

2.8/lib/active_record/transactions.rb:252:

2.8/1lib/active_record/transactions.rb:240:

/usr/share/foreman/app/models/concerns/foreman/sti.rb:29:in "“save_with_type'
/usr/share/foreman/db/migrate/20140710132249_extract_nic_attributes.rb:47:in “block in up'
/usr/share/foreman/db/migrate/20140710132249_extract_nic_attributes.rb:38:in “each'
/usr/share/foreman/db/migrate/20140710132249_extract_nic_attributes.rb:38:in “up'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
"block (2 levels) in migrate'
/opt/rh/rubyl93/root/usr/share/ruby/benchmark.rb:280:1in
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘block in migrate'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
abstract/connection_pool.rb:123:in ‘with_connection’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘migrate’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘migrate’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
"block (2 levels) in migrate'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘call!
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
"ddl_transaction'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
"block in migrate'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘each'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘migrate’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
i
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
‘migrate'’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.
ake:153:in "block (2 levels) in <top (required)>"'
/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:205:1in
/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:205:1in
/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:200:1in
/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:200:1in
/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:158:1in

2.8/1lib/active_record/migration.rb:410:in

‘measure’
2.8/1lib/active_record/migration.rb:410:in

2.8/1ib/active_record/connection_adapters/
2.8/1lib/active_record/migration.rb:389:in
2.8/1lib/active_record/migration.rb:528:in
2.8/1lib/active_record/migration.rb:720:in
2.8/1lib/active_record/migration.rb:777:in
2.8/1lib/active_record/migration.rb:777:in
2.8/1lib/active_record/migration.rb:719:in
2.8/1lib/active_record/migration.rb:700:in
2.8/1ib/active_record/migration.rb:700:in
2.8/1lib/active_record/migration.rb:570:in
2.8/1lib/active_record/migration.rb:551:in
2.8/1lib/active_record/railties/databases.r
‘call!

"block in execute'

‘each'

‘execute'
"block in invoke_with_call_chain'

/opt/rh/rubyl93/root/usr/share/ruby/monitor.rb:211:in ‘mon_synchronize'

/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:151:in
/opt/rh/rubyl93/root/usr/share/ruby/rake/task.rb:144:in
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/share/ruby/rake/application.rb:
/opt/rh/rubyl93/root/usr/bin/rake:32:in " <main>'

Tasks: TOP => db:migrate

“invoke_with_call_chain'

‘invoke'

116:in "~ invoke_task'

94:in “block (2 levels) in top_level'
94:in "each'

94:in “block in top_level'

133:in "standard_exception_handling’
88:in “top_level'

66:in "block in run'

133:in "“standard_exception_handling'
63:in ‘run'

History

#1 - 04/29/2015 11:33 AM - Dominic Cleal
- translation missing: en.field_release set to 50

#2 - 05/06/2015 06:45 AM - Marek Hulan
- Status changed from New to Assigned

- Assignee set to Marek Hulan

#3 - 05/07/2015 05:03 AM - Marek Hulan

- Status changed from Assigned to Resolved

It took me a while before | realize that you're trying to upgrade from 1.6 (or older) to 1.8 directly, which is not supported. | suggest you first upgrade to
1.7 and then to 1.8. If you want to try to fix your current installation, you can try to apply my patch to the failing migration from here
https://github.com/ares/foreman/commit/08111d245d4ca0db8d588ce007920a7f480d8d60 but | don't think such patch would get into develop branch.

If | got it wrong, please reopen the ticket.

#4 - 05/20/2015 03:19 AM - Dominic Cleal

- translation missing: en.field_release deleted (50)
https://github.com/ares/foreman/commit/08111d245d4ca0db8d588ce007920a7f480d8d60
